Index: TvEngine3/TVLibrary/TvPlugin/TvPlugin/TvGuideBase.cs
===================================================================
--- TvEngine3/TVLibrary/TvPlugin/TvPlugin/TvGuideBase.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TvPlugin/TvPlugin/TvGuideBase.cs	(working copy)
@@ -128,6 +128,7 @@
     private long _currentStartTime = 0;
     private long _currentEndTime = 0;
     private Program _currentProgram = null;
+    private static Schedule currentSchedule;
     private bool _needUpdate = false;
     private DateTime m_dtStartTime = DateTime.Now;
     private ArrayList _colorList = new ArrayList();
@@ -169,6 +170,10 @@
     private GUIButton3PartControl _programNotRunningTemplate;
     private GUIButton3PartControl _programRunningTemplate;
     
+
+    private bool _useQuickRecordMenu = false;
+    private readonly List<ScheduleRecordingType> _quickRecordMenuSchedules = new List<ScheduleRecordingType>();
+    
     // current minimum/maximum indexes
     //private int MaxXIndex; // means rows here (channels)
     private int MinYIndex; // means cols here (programs/time)
@@ -252,6 +257,57 @@
         _hdtvProgramText = xmlreader.GetValueAsString("mytv", "hdtvProgramText", "(HDTV)");
         _guideContinuousScroll = xmlreader.GetValueAsBool("mytv", "continuousScrollGuide", false);
         _loopDelay = xmlreader.GetValueAsInt("gui", "listLoopDelay", 0);
+
+        //  Load the quick record menu settings
+        _useQuickRecordMenu = xmlreader.GetValueAsBool("mytv", "usequickrecordmenu", false);
+
+        string[] selectedQuickRecordSchedules = xmlreader.GetValueAsString("mytv", "selectedquickrecordschedules", string.Empty).Split(',');
+
+          //  Check loaded items
+        foreach (string selectedSchedule in selectedQuickRecordSchedules)
+        {
+          ScheduleRecordingType schedule = (ScheduleRecordingType)(-1);
+
+          switch (selectedSchedule)
+          {
+            case "Once":
+              schedule = ScheduleRecordingType.Once;
+              break;
+            case "Daily":
+              schedule = ScheduleRecordingType.Daily;
+              break;
+            case "Weekly":
+              schedule = ScheduleRecordingType.Weekly;
+              break;
+            case "EveryTimeOnThisChannel":
+              schedule = ScheduleRecordingType.EveryTimeOnThisChannel;
+              break;
+            case "EveryTimeOnEveryChannel":
+              schedule = ScheduleRecordingType.EveryTimeOnEveryChannel;
+              break;
+            case "Weekends":
+              schedule = ScheduleRecordingType.Weekends;
+              break;
+            case "WorkingDays":
+              schedule = ScheduleRecordingType.WorkingDays;
+              break;
+            case "WeeklyEveryTimeOnThisChannel":
+              schedule = ScheduleRecordingType.WeeklyEveryTimeOnThisChannel;
+              break;
+            case "SeriesLink":
+              schedule = ScheduleRecordingType.SeriesLink;
+              break;
+          }
+
+          if (schedule != (ScheduleRecordingType)(-1) && !_quickRecordMenuSchedules.Contains(schedule))
+            _quickRecordMenuSchedules.Add(schedule);
+
+        }
+
+        //  If there are no schedules listed, never use the quick record menu
+        if (_quickRecordMenuSchedules.Count == 0)
+          _useQuickRecordMenu = false;
+
       }
       _useNewRecordingButtonColor =
         Utils.FileExistsInCache(Path.Combine(GUIGraphicsContext.Skin, @"media\tvguide_recButton_Focus_middle.png"));
@@ -3821,10 +3877,129 @@
           }
         }
       }
+
+      //  Else if we want to use the quick record menu
+      else if (_useQuickRecordMenu)
+      {
+        //  Open the quick record menu
+        GUIDialogMenu quickRecordMenu = (GUIDialogMenu)GUIWindowManager.GetWindow((int)Window.WINDOW_DIALOG_MENU);
+        if (quickRecordMenu == null)
+        {
+          ShowProgramInfo();
+          return;
+        }
+
+        quickRecordMenu.Reset();
+        quickRecordMenu.SetHeading(GUILocalizeStrings.Get(200093)); //200093=Quick record
+
+        //  If the program has series link information (Sky UK/IT/AU / FreeSat)
+        bool seriesLinkAvailable = (_currentProgram.SeriesId != 0);
+
+        //  Maintain a lookup so we know which schedule the user selected
+        Dictionary<int, ScheduleRecordingType> scheduleIndexLookup = new Dictionary<int, ScheduleRecordingType>();
+
+        int currentIndex = 0;
+
+        //  Loop through all schedules to be added
+        foreach (ScheduleRecordingType schedule in _quickRecordMenuSchedules)
+        {
+          string scheduleDescription = string.Empty;
+
+          switch (schedule)
+          {
+            case ScheduleRecordingType.Daily:
+              //  Record every day at this time
+              scheduleDescription = GUILocalizeStrings.Get(615);
+              break;
+
+            case ScheduleRecordingType.EveryTimeOnEveryChannel:
+              //  Record every time on every channel
+              scheduleDescription = GUILocalizeStrings.Get(613);
+              break;
+
+            case ScheduleRecordingType.EveryTimeOnThisChannel:
+              //  Record every time on this channel
+              scheduleDescription = GUILocalizeStrings.Get(612);
+              break;
+
+            case ScheduleRecordingType.Once:
+              //  Record once
+              scheduleDescription = GUILocalizeStrings.Get(611);
+              break;
+
+            case ScheduleRecordingType.SeriesLink:
+              //  Record series
+              scheduleDescription = GUILocalizeStrings.Get(200092);
+              break;
+
+            case ScheduleRecordingType.Weekends:
+              //  Record weekends
+              scheduleDescription = GUILocalizeStrings.Get(1051);
+              break;
+
+            case ScheduleRecordingType.Weekly:
+              //  Record every week at this time
+              scheduleDescription = GUILocalizeStrings.Get(614);
+              break;
+
+            case ScheduleRecordingType.WeeklyEveryTimeOnThisChannel:
+              //  Weekly on this channel
+              scheduleDescription = GUILocalizeStrings.Get(990000);
+              break;
+
+            case ScheduleRecordingType.WorkingDays:
+              //  Record weekdays
+              scheduleDescription = GUILocalizeStrings.Get(672);
+              break;
+
+          }
+
+          //  If valid schedule
+          if (scheduleDescription != string.Empty)
+          {
+            //  If series link, check it is available and skip of not
+            if (schedule == ScheduleRecordingType.SeriesLink && !seriesLinkAvailable)
+              continue;
+
+            quickRecordMenu.Add(scheduleDescription);
+
+            scheduleIndexLookup.Add(currentIndex, schedule);
+
+            currentIndex++;
+          }
+
+        }
+
+        //  Programme info
+        quickRecordMenu.AddLocalizedString(200094);
+
+        quickRecordMenu.DoModal(GetID);
+        int selectedIndex = quickRecordMenu.SelectedLabel;
+
+        //  If none selected
+        if (selectedIndex == -1)
+          return;
+
+        //  Get the selected schedule from the lookup
+        //  If it is not there, the user has chosen to go to the programme information window
+        ScheduleRecordingType selectedSchedule;
+        if (!scheduleIndexLookup.TryGetValue(selectedIndex, out selectedSchedule))
+        {
+          ShowProgramInfo();
+          return;
+        }
+
+        //  Else try and create the schedule
+        TVProgramInfo.CreateProgram(_currentProgram, (int)selectedSchedule, GetID);
+
+        //  Refresh the gui
+        Update(true);
+
+      }
+
+      //  Else show the program info screen
       else
-      {
         ShowProgramInfo();
-      }
     }
 
     /// <summary>
Index: TvEngine3/TVLibrary/TvPlugin/TvPlugin/TvPlugin.csproj
===================================================================
--- TvEngine3/TVLibrary/TvPlugin/TvPlugin/TvPlugin.csproj	(revision 27484)
+++ TvEngine3/TVLibrary/TvPlugin/TvPlugin/TvPlugin.csproj	(working copy)
@@ -2,7 +2,7 @@
   <PropertyGroup>
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{1526A789-1DE2-4A8B-AA4B-5382A617C4F8}</ProjectGuid>
     <OutputType>Library</OutputType>
Index: TvEngine3/TVLibrary/TvPlugin/TvPlugin/TVProgramInfo.cs
===================================================================
--- TvEngine3/TVLibrary/TvPlugin/TvPlugin/TVProgramInfo.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TvPlugin/TvPlugin/TVProgramInfo.cs	(working copy)
@@ -328,6 +328,9 @@
         {
           CurrentProgram = new Program(value.IdChannel, value.StartTime, value.EndTime, value.ProgramName, "",
                                        "", Program.ProgramState.None, DateTime.MinValue, "", "", "", "", 0, "", 0);
+
+          CurrentProgram.SeriesId = value.SeriesId;
+
         }        
       }
     }
@@ -336,7 +339,7 @@
 
     #region Static methods
 
-    private static string GetRecordingDateTime(Schedule rec)
+    internal static string GetRecordingDateTime(Schedule rec)
     {
       return String.Format("{0} {1} - {2}",
                            Utils.GetShortDayString(rec.StartTime),
@@ -344,7 +347,7 @@
                            rec.EndTime.ToString("t", CultureInfo.CurrentCulture.DateTimeFormat));
     }
 
-    private static bool IsRecordingProgram(Program program, out Schedule recordingSchedule,
+    internal static bool IsRecordingProgram(Program program, out Schedule recordingSchedule,
                                            bool filterCanceledRecordings)
     {
       recordingSchedule = null;
@@ -1025,11 +1028,11 @@
       Schedule recordingSchedule;
       if (!anyUpcomingEpisodesRecording && currentSchedule != null)
       {
-        CancelProgram(program, currentSchedule);
+        CancelProgram(program, currentSchedule, GetID);
       }
       else if (IsRecordingProgram(program, out recordingSchedule, true)) // check if schedule is already existing
       {
-        CancelProgram(program, recordingSchedule);
+        CancelProgram(program, recordingSchedule, GetID);
       }
       else
       {
@@ -1046,18 +1049,18 @@
           }
           else
           {
-            CreateProgram(program, (int)ScheduleRecordingType.Once);
+            CreateProgram(program, (int)ScheduleRecordingType.Once, GetID);
           }
         }
         else
         {
-          CreateProgram(program, (int)ScheduleRecordingType.Once);
+          CreateProgram(program, (int)ScheduleRecordingType.Once, GetID);
         }
       }
       Update();
     }
 
-    private void CancelProgram(Program program, Schedule schedule)
+    internal static void CancelProgram(Program program, Schedule schedule, int windowId)
     {
       Log.Debug("TVProgammInfo.CancelProgram - programm = {0}", program.ToString());
       Log.Debug("                            - schedule = {0}", schedule.ToString());
@@ -1095,7 +1098,7 @@
           dlg.AddLocalizedString(981); //Cancel this show
         }
         dlg.AddLocalizedString(982); //Delete this entire schedule
-        dlg.DoModal(GetID);
+        dlg.DoModal(windowId);
         if (dlg.SelectedLabel == -1)
         {
           return;
@@ -1129,13 +1132,13 @@
       }
     }
 
-    private void ResetCurrentScheduleAndProgram()
+    private static void ResetCurrentScheduleAndProgram()
     {
       currentProgram = initialProgram;
       currentSchedule = null;
     }
 
-    private void ResetCurrentScheduleAndProgram(Schedule schedule)
+    private static void ResetCurrentScheduleAndProgram(Schedule schedule)
     {
       if (
         currentSchedule == null ||
@@ -1148,7 +1151,7 @@
       }
     }
 
-    private void CreateProgram(Program program, int scheduleType)
+    internal static void CreateProgram(Program program, int scheduleType, int windowId)
     {
       Log.Debug("TVProgramInfo.CreateProgram: program = {0}", program.ToString());
       Schedule schedule;
@@ -1170,6 +1173,10 @@
           schedule.PreRecordInterval = saveSchedule.PreRecordInterval;
           schedule.PostRecordInterval = saveSchedule.PostRecordInterval;
           schedule.ScheduleType = (int)ScheduleRecordingType.Once; // needed for layer.GetConflictingSchedules(...)
+
+          //  If series link
+          if (scheduleType == (int)ScheduleRecordingType.SeriesLink)
+            schedule.SeriesId = program.SeriesId;
         }
       }
       else
@@ -1180,6 +1187,10 @@
         schedule.PreRecordInterval = Int32.Parse(layer.GetSetting("preRecordInterval", "5").Value);
         schedule.PostRecordInterval = Int32.Parse(layer.GetSetting("postRecordInterval", "5").Value);
         schedule.ScheduleType = scheduleType;
+
+        //  If series link
+        if (scheduleType == (int)ScheduleRecordingType.SeriesLink)
+          schedule.SeriesId = program.SeriesId;
       }
 
       // check if this program is conflicting with any other already scheduled recording
@@ -1214,7 +1225,7 @@
             dlg.AddConflictRecording(item);
           }
           dlg.ConflictingEpisodes = (scheduleType != (int)ScheduleRecordingType.Once);
-          dlg.DoModal(GetID);
+          dlg.DoModal(windowId);
           switch (dlg.SelectedLabel)
           {
             case 0: // Skip new Recording
@@ -1232,7 +1243,7 @@
                                 Program.ProgramState.None,
                                 DateTime.MinValue, string.Empty, string.Empty, string.Empty, string.Empty, -1,
                                 string.Empty, -1);
-                  CancelProgram(prog, Schedule.Retrieve(conflict.IdSchedule));
+                  CancelProgram(prog, Schedule.Retrieve(conflict.IdSchedule), windowId);
                 }
                 break;
               }
@@ -1313,6 +1324,8 @@
       {
         dlg.Reset();
         dlg.SetHeading(GUILocalizeStrings.Get(616)); //616=Select Schedule type
+
+
         //610=None
         //611=Record once
         //612=Record everytime on this channel
@@ -1327,6 +1340,14 @@
         dlg.Add(GUILocalizeStrings.Get(WeekEndTool.GetText(DayType.Record_WeekendDays)));
         dlg.AddLocalizedString(990000); // 990000=Weekly everytime on this channel
 
+        //  If the program has series link information (Sky UK/IT/AU / FreeSat)
+        bool seriesLinkAvailable = (CurrentProgram.SeriesId != 0);
+        if (seriesLinkAvailable)
+        {
+          //  200092=Series Link
+          dlg.AddLocalizedString(200092);
+        }
+
         dlg.DoModal(GetID);
         if (dlg.SelectedLabel == -1)
         {
@@ -1334,6 +1355,7 @@
         }
 
         int scheduleType = (int)ScheduleRecordingType.Once;
+
         switch (dlg.SelectedLabel)
         {
           case 0: //once
@@ -1360,9 +1382,14 @@
           case 7://Weekly everytime, this channel
             scheduleType = (int)ScheduleRecordingType.WeeklyEveryTimeOnThisChannel;
             break;
+          case 8: //  Series Link
+            scheduleType = (int)ScheduleRecordingType.SeriesLink;
+            break;
         }
-        CreateProgram(CurrentProgram, scheduleType);
+        
 
+        CreateProgram(CurrentProgram, scheduleType, GetID);
+
         if (scheduleType == (int)ScheduleRecordingType.Once)
         {
           //check if this program is interrupted (for example by a news bulletin)
@@ -1388,7 +1415,7 @@
                 dlgYesNo.DoModal(GetID);
                 if (dlgYesNo.IsConfirmed)
                 {
-                  CreateProgram(nextNext, scheduleType);
+                  CreateProgram(nextNext, scheduleType, GetID);
                   Update();
                 }
               }
Index: TvEngine3/TVLibrary/TvPlugin/TvPlugin/TVScheduler.cs
===================================================================
--- TvEngine3/TVLibrary/TvPlugin/TvPlugin/TVScheduler.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TvPlugin/TvPlugin/TVScheduler.cs	(working copy)
@@ -776,9 +776,13 @@
                  default:
                      day = GUILocalizeStrings.Get(17);
                      break;
-          }
+            }
              item.Label2 = GUILocalizeStrings.Get(990001, new object[] { day, rec.ReferencedChannel().DisplayName });
-             break;              
+             break;
+
+           case (int)ScheduleRecordingType.SeriesLink:
+             item.Label2 = GUILocalizeStrings.Get(200095, new object[] { rec.ReferencedChannel().DisplayName });
+             break;
         }
         }
         else
Index: TvEngine3/TVLibrary/TvPlugin/TvPlugin/TVSearch.cs
===================================================================
--- TvEngine3/TVLibrary/TvPlugin/TvPlugin/TVSearch.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TvPlugin/TvPlugin/TVSearch.cs	(working copy)
@@ -1173,6 +1173,12 @@
         dlg.Add(GUILocalizeStrings.Get(WeekEndTool.GetText(DayType.Record_WeekendDays)));
         dlg.Add(GUILocalizeStrings.Get(990000));  // 990000=Weekly everytime on this channel
 
+        //  If the program has series link information (Sky UK/IT/AU / FreeSat)
+        bool seriesLinkAvailable = (program.SeriesId != 0);
+
+        if (seriesLinkAvailable)
+          dlg.Add(GUILocalizeStrings.Get(200092));  // 200092=Series link
+
         dlg.DoModal(GetID);
         if (dlg.SelectedLabel == -1)
         {
@@ -1232,6 +1238,13 @@
           case 8://Weekly everytime, this channel
             rec.ScheduleType = (int)ScheduleRecordingType.WeeklyEveryTimeOnThisChannel;
             break;
+          case 9://Series link
+            rec.ScheduleType = (int)ScheduleRecordingType.SeriesLink;
+            
+            //  Set series id
+            rec.SeriesId = program.SeriesId;
+
+            break;
         }
         rec.Persist();
         server.OnNewSchedule();
Index: TvEngine3/TVLibrary/TvService/Epg/EpgCard.cs
===================================================================
--- TvEngine3/TVLibrary/TvService/Epg/EpgCard.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TvService/Epg/EpgCard.cs	(working copy)
@@ -28,6 +28,8 @@
 using TvLibrary.Epg;
 using TvEngine.Events;
 using System.Threading;
+using DirectShowLib.BDA;
+using TvLibrary.Implementations.Helper.Providers;
 
 namespace TvService
 {
@@ -72,6 +74,11 @@
     private IUser _user;
     private readonly EpgDBUpdater _dbUpdater;
 
+    /// <summary>
+    /// Mode (normal or provider - Sky is grabbed by tuning a transponder rather than a specific channel)
+    /// </summary>
+    private eEPGGrabMode _epgGrabMode = eEPGGrabMode.Normal;
+
     #endregion
 
     #region ctor
@@ -129,6 +136,17 @@
       get { return (_state != EpgState.Idle); }
     }
 
+    /// <summary>
+    /// Gets the EPG grab mode
+    /// </summary>
+    public sealed override BaseEpgGrabber.eEPGGrabMode EPGGrabMode
+    {
+      get
+      {
+        return _epgGrabMode;
+      }
+    }
+
     #endregion
 
     #region epg callback
@@ -192,14 +210,18 @@
         {
           //no epg found for this transponder
           Log.Epg("Epg: card:{0} no epg found", _user.CardId);
-          _currentTransponder.InUse = false;
-          _currentTransponder.OnTimeOut();
 
+          //  Null if sky epg grabbing
+          if (_currentTransponder != null)
+          {
+            _currentTransponder.InUse = false;
+            _currentTransponder.OnTimeOut();
+          }
+
           _state = EpgState.Idle;
           _tvController.StopGrabbingEpg(_user);
           _tvController.PauseCard(_user);
           _user.CardId = -1;
-          _currentTransponder.InUse = false;
           return 0;
         }
 
@@ -238,6 +260,9 @@
       _currentTransponder = TransponderList.Instance.CurrentTransponder;
       Channel channel = _currentTransponder.CurrentChannel;
 
+      //  Normal grab (not by transponder)
+      _epgGrabMode = eEPGGrabMode.Normal;
+
       Log.Epg("EpgCard: grab epg on card: #{0} transponder: #{1} ch:{2} ", _card.IdCard,
               TransponderList.Instance.CurrentIndex, channel.DisplayName);
 
@@ -278,8 +303,247 @@
       _isRunning = false;
     }
 
+    /// <summary>
+    /// Checks if it is time to grab the EPG for any specific providers.  Returns true if grab started, or false otherwise
+    /// </summary>
+    public bool GrabProviderEPG(int reGrabAfterMinutes)
+    {
+      try
+      {
+        CardType type = _tvController.Type(Card.IdCard);
+
+        //  If satellite card
+        if (type == CardType.DvbS)
+        {
+          if (GrabSkyUKEPG(reGrabAfterMinutes))
+            return true;
+
+          if (GrabSkyItalyEPG(reGrabAfterMinutes))
+            return true;
+        }
+      }
+      catch (Exception ex)
+      {
+        //  Ensure normal mode is set back and log error
+        _epgGrabMode = eEPGGrabMode.Normal;
+        Log.Error("Exception detected in GrabProviderEpg():\r\n\r\n" + ex.ToString());
+      }
+
+      return false;
+    }
+
+    #region Provider EPGs
+
+    /// <summary>
+    /// Checks if the EPG for Sky UK should be grabbed and starts it if so.  Returns if grabbing was started
+    /// </summary>
+    /// <returns></returns>
+    private bool GrabSkyUKEPG(int reGrabAfterMinutes)
+    {
+      //  If we are not set to grab the Sky UK Epg, return here
+      if (!SkyUK.Instance.EPGGrabbingEnabled)
+        return false;
+
+      //  Get the last grab time
+      DateTime lastEpgGrabTime = SkyUK.Instance.LastEPGGrabTime;
+
+      TimeSpan timeSinceLastGrab = DateTime.Now - lastEpgGrabTime;
+
+      //  If the time since last grab does not reach the threshold, return
+      if (timeSinceLastGrab.TotalMinutes < reGrabAfterMinutes)
+        return false;
+
+      Log.Epg("Initializing grab for Sky UK");
+
+      //  Find all channels on the default transponder
+      IList<TuningDetail> defaultTransponderChannels = TuningDetail.Find(SkyUK.Instance.DefaultTransponderFrequency, 500, (int)SkyUK.Instance.DefaultTransponderPolarisation, (int)SkyUK.Instance.DefaultTransponderInnerFEC, SkyUK.Instance.DefaultTransponderSymbolRate, SkyUK.Instance.NetworkId);
+
+      //  Check at leat 1 channel was found for the default transponder
+      if (defaultTransponderChannels == null || defaultTransponderChannels.Count == 0)
+      {
+        Log.Epg("Error cannot start EPG grabbing for Sky UK as no channels could be found for the default transponder");
+
+        //  Postpone until next grab
+        SkyUK.Instance.LastEPGGrabTime = DateTime.Now;
+
+        return false;
+      }
+
+      Log.Epg("There are " + defaultTransponderChannels.Count.ToString() + " known channels on the default transponder");
+
+      TvBusinessLayer layer = new TvBusinessLayer();
+
+      //  Loop through all channels on the default transponder until epg grabbing is started successfully
+      foreach (TuningDetail currentChannelTuning in defaultTransponderChannels)
+      {
+        Channel referencedChannel = currentChannelTuning.ReferencedChannel();
+
+        if (referencedChannel == null)
+          continue;
+        
+        //  Check the card can tune this channel
+        if (!Card.canTuneTvChannel(referencedChannel.IdChannel))
+        {
+          Log.Epg("Card " + Card.IdCard + " cannot tune '" + referencedChannel.DisplayName + "', trying next");
+          continue;
+        }
+
+        Log.Epg("Tuning to '" + referencedChannel.DisplayName + "' to grab EPG for Sky UK");
+
+        //  Set idle
+        _state = EpgState.Idle;
+
+        _isRunning = true;
+        _user = new User("Sky UK", false, -1);
+
+        //  Sky is grabbed by tuning the default transponder rather than a specific channel
+        _epgGrabMode = eEPGGrabMode.SkyUK;
+
+        IChannel channelTuning = layer.GetTuningChannelByType(referencedChannel, currentChannelTuning.ChannelType);
+
+        //  Try to grab and update last grab time if successful
+        if (GrabEpgForChannel(referencedChannel, channelTuning, _card))
+        {
+          //  Succeeded
+          _state = EpgState.Grabbing;
+          _grabStartTime = DateTime.Now;
+
+          try
+          {
+            _epgTimer.Enabled = true;
+          }
+          catch (ObjectDisposedException)
+          {
+            return false;
+          }
+
+          Log.Epg("EPG grab for Sky UK started successfully");
+
+          return true;
+        }
+        else
+        {
+          _epgGrabMode = eEPGGrabMode.Normal;
+
+          Log.Epg("Failed to start grabbing EPG for Sky UK on channel '" + referencedChannel.DisplayName + "'.  Trying next");
+        }
+      }
+
+      Log.Epg("Failed to start grabbing EPG for Sky UK on any channel in transponder list");
+
+      //  Postpone until next grab
+      SkyUK.Instance.LastEPGGrabTime = DateTime.Now;
+
+      return false;
+    }
+
+    /// <summary>
+    /// Checks if the EPG for Sky Italy should be grabbed and starts it if so.  Returns if grabbing was started
+    /// </summary>
+    /// <returns></returns>
+    private bool GrabSkyItalyEPG(int reGrabAfterMinutes)
+    {
+      //  If we are not set to grab the Sky Italy Epg, return here
+      if (!SkyItaly.Instance.EPGGrabbingEnabled)
+        return false;
+
+      //  Get the last grab time
+      DateTime lastEpgGrabTime = SkyItaly.Instance.LastEPGGrabTime;
+
+      TimeSpan timeSinceLastGrab = DateTime.Now - lastEpgGrabTime;
+
+      //  If the time since last grab does not reach the threshold, return
+      if (timeSinceLastGrab.TotalMinutes < reGrabAfterMinutes)
+        return false;
+
+      Log.Epg("Initializing grab for Sky Italy");
+
+      //  Find all channels on the default transponder
+      IList<TuningDetail> defaultTransponderChannels = TuningDetail.Find(SkyItaly.Instance.DefaultTransponderFrequency, 500, (int)SkyItaly.Instance.DefaultTransponderPolarisation, (int)SkyItaly.Instance.DefaultTransponderInnerFEC, SkyItaly.Instance.DefaultTransponderSymbolRate, SkyItaly.Instance.NetworkId);
+
+      //  Check at leat 1 channel was found for the default transponder
+      if (defaultTransponderChannels == null || defaultTransponderChannels.Count == 0)
+      {
+        Log.Epg("Error cannot start EPG grabbing for Sky Italy as no channels could be found for the default transponder");
+
+        //  Postpone until next grab
+        SkyItaly.Instance.LastEPGGrabTime = DateTime.Now;
+
+        return false;
+      }
+
+      Log.Epg("There are " + defaultTransponderChannels.Count.ToString() + " known channels on the default transponder");
+
+      TvBusinessLayer layer = new TvBusinessLayer();
+
+      //  Loop through all channels on the default transponder until epg grabbing is started successfully
+      foreach (TuningDetail currentChannelTuning in defaultTransponderChannels)
+      {
+        Channel referencedChannel = currentChannelTuning.ReferencedChannel();
+
+        if (referencedChannel == null)
+          continue;
+
+        //  Check the card can tune this channel
+        if (!Card.canTuneTvChannel(referencedChannel.IdChannel))
+        {
+          Log.Epg("Card " + Card.IdCard + " cannot tune '" + referencedChannel.DisplayName + "', trying next");
+          continue;
+        }
+
+        Log.Epg("Tuning to '" + referencedChannel.DisplayName + "' to grab EPG for Sky Italy");
+
+        //  Set idle
+        _state = EpgState.Idle;
+
+        _isRunning = true;
+        _user = new User("Sky Italy", false, -1);
+
+        //  Sky is grabbed by tuning the default transponder rather than a specific channel
+        _epgGrabMode = eEPGGrabMode.SkyItaly;
+
+        IChannel channelTuning = layer.GetTuningChannelByType(referencedChannel, currentChannelTuning.ChannelType);
+
+        //  Try to grab and update last grab time if successful
+        if (GrabEpgForChannel(referencedChannel, channelTuning, _card))
+        {
+          //  Succeeded
+          _state = EpgState.Grabbing;
+          _grabStartTime = DateTime.Now;
+
+          try
+          {
+            _epgTimer.Enabled = true;
+          }
+          catch (ObjectDisposedException)
+          {
+            return false;
+          }
+
+          Log.Epg("EPG grab for Sky Italy started successfully");
+
+          return true;
+        }
+        else
+        {
+          _epgGrabMode = eEPGGrabMode.Normal;
+
+          Log.Epg("Failed to start grabbing EPG for Sky Italy on channel '" + referencedChannel.DisplayName + "'.  Trying next");
+        }
+      }
+
+      Log.Epg("Failed to start grabbing EPG for Sky Italy on any channel in transponder list");
+
+      //  Postpone until next grab
+      SkyItaly.Instance.LastEPGGrabTime = DateTime.Now;
+
+      return false;
+    }
+
     #endregion
 
+    #endregion
+
     #region private members
 
     /// <summary>
@@ -637,12 +901,15 @@
       //if card is not idle anymore we return
       if (IsCardIdle(_user) == false)
       {
-        _currentTransponder.InUse = false;
+        if (_epgGrabMode == eEPGGrabMode.Normal)
+          _currentTransponder.InUse = false;
+
         return;
       }
       Log.Epg("Epg: card:{0} Updating database with new programs", _user.CardId);
       bool timeOut = false;
       _dbUpdater.ReloadConfig();
+
       try
       {
         foreach (EpgChannel epgChannel in _epg)
@@ -671,7 +938,8 @@
       }
       finally
       {
-        if (timeOut == false)
+
+        if (timeOut == false && _epgGrabMode == eEPGGrabMode.Normal && _currentTransponder != null)
         {
           _currentTransponder.OnTimeOut();
         }
@@ -680,7 +948,29 @@
           _tvController.StopGrabbingEpg(_user);
           _tvController.PauseCard(_user);
         }
-        _currentTransponder.InUse = false;
+
+        if (_epgGrabMode == eEPGGrabMode.Normal && _currentTransponder != null)
+          _currentTransponder.InUse = false;
+
+        try
+        {
+          //  If Sky UK grab and a timeout wasn't triggered
+          if (_epgGrabMode == eEPGGrabMode.SkyUK && !timeOut)
+            SkyUK.Instance.LastEPGGrabTime = DateTime.Now;
+
+          //  If Sky Italy grab and a timeout wasn't triggered
+          if (_epgGrabMode == eEPGGrabMode.SkyItaly && !timeOut)
+            SkyItaly.Instance.LastEPGGrabTime = DateTime.Now;
+
+        }
+        catch (Exception ex)
+        {
+          Log.Error("Exception in UpdateDatabaseThread(): " + ex.ToString());
+        }
+
+        //  Ensure set back to normal
+        _epgGrabMode = eEPGGrabMode.Normal;
+
         _state = EpgState.Idle;
         _user.CardId = -1;
         _tvController.Fire(this, new TvServerEventArgs(TvServerEventType.ProgramUpdated));
